<?php
virtual('html-head.html');

require 'incl.functions.php';

if ($_SERVER['REQUEST_METHOD'] == 'GET') {
?>
<body>
<h1>Installation</h1>
<form method="POST" action="install">
<center>
<table>
<tr>
<th align="right">Operating system:</th>
<td><?php echo _linux_mode_ ? 'Unix type' : 'OS/2'; ?></td>
</tr>
<tr>
<th align="right">Host:</th>
<td><input name="host" size=32 maxlenght=128 value="localhost" /></td>
</tr>
<tr>
<th align="right">Database:</th>
<td><input name="db" size=32 maxlenght=64 value="memodisx" /></td>
</tr>
<tr>
<th align="right">User:</th>
<td><input name="user" size=32 maxlenght=64 value="memodisx" /></td>
</tr>
<tr>
<th align="right">Password:</th>
<td><input name="pw" size=32 maxlenght=64 /></td>
</tr>
<tr>
<th align="right">zip:</th>
<td><select name="zip">
<option value="0">-</option>
<option value="1">InfoZip</option>
</select></td>
</tr>
<tr>
<th align="right">tar:</th>
<td><select name="tar">
<option value="0">-</option>
<option value="1">GNU tar (with -z)</option>
<option value="-1">other tar</option>
</select></td>
</tr>
<tr>
<th align="right">gzip:</th>
<td><select name="gzip">
<option value='0'>-</option>
<option value='1'>gunzip -c</option>
<option value='-1'>gzip -cd</option>
</select></td>
</tr>
<tr>
<th align="right">bzip2:</th>
<td><select name="bzip2">
<option value='0'>-</option>
<option value='1'>bunzip2 -ck</option>
<option value='-1'>bzip2 -cdk</option>
</select></td>
</tr>
<?php
if (_linux_mode_) {
?>
<tr>
<th align="right">CD 0:</th>
<td><input name="cd[]" size=32 maxlenght=64 value="/mnt/cdrom" /></td>
</tr>
<tr>
<th align="right">CD 1:</th>
<td><input name="cd[]" size=32 maxlenght=64 value="/mnt/cdrom1" /></td>
</tr>
<tr>
<th align="right">CD 2:</th>
<td><input name="cd[]" size=32 maxlenght=64 value="/mnt/cdrom2" /></td>
</tr>
<tr>
<th align="right">CD 3:</th>
<td><input name="cd[]" size=32 maxlenght=64 value="/mnt/cdrom3" /></td>
</tr>
<?php
}
else {
  exec('drvs', $x);
  $drvs = explode(' ', $x[0]);
  for ($i = 0;  $i < count($drvs);  $i++) {
?>
<tr>
<th align="right"><?php echo $drvs[$i] ?></th>
<td><input name="cd[]" type=checkbox value="<?php echo $drvs[$i] ?>" /></td>
</tr>
<?php
  }
}
?>
<tr><th /><td><input type=submit /></td></tr>
</table>
</center>
</form>
<?php
}
elseif (file_exists('incl.demo.php')) {
  define(_notavail_, '<p class="error">This function is not available in the demo version.</p>');
  include('incl.demo.php');
}
elseif ($_SERVER['REQUEST_METHOD'] == 'POST') {
  $host = $_POST['host'];
  $user = $_POST['user'];
  $db = $_POST['db'];
  $pw = $_POST['pw'];
  $cd = $_POST['cd'];
  $tar = $_POST['tar'];
  $zip = $_POST['zip'];
  $gzip = $_POST['gzip'];
  $bzip2 = $_POST['bzip2'];
  if ($tar && !_linux_mode_) $tar = -1;   # This line forces non-GNU tar in OS/2.
  $fh = fopen('incl.constants.php', 'w');
  if (!$fh) die('<p class="error">Cannot create "incl.constants.php", make sure '
           . 'that the MemoDisx directory has write permission for Apache.</p>');
  fputs($fh, "<?php\n# This is generated file, do not edit!\n");
  fputs($fh, "define(_host_, '$host');\n");
  fputs($fh, "define(_user_, '$user');\n");
  fputs($fh, "define(_db_, '$db');\n");
  fputs($fh, "define(_pw_, '$pw');\n");
  fputs($fh, "define(_tar_, '$tar');\n");
  fputs($fh, "define(_zip_, '$zip');\n");
  fputs($fh, "define(_gzip_, '$gzip');\n");
  fputs($fh, "define(_bzip2_, '$bzip2');\n");
  $prefix = '$_cd_ = array(';
  reset($cd);
  while (list($k, $v) = each($cd)) {
    if (trim($v)) {
      fputs($fh, "$prefix\n  '$v'");
      $prefix = ',';
    }
  }
  fputs($fh, "\n);\n?>\n");
  fclose($fh);
  $sq = mysql_pconnect($host, $user, $pw);
  $q = 'create table nonames (noname int unsigned not null auto_increment primary key);';
  mysql_db_query($db, $q, $sq);
  $q = 'create table names ('
     . 'id int unsigned not null auto_increment primary key,'
     . 'name varchar(255) binary not null,'
     . 'unique(name));';
  mysql_db_query($db, $q, $sq);
  $q = 'create table nodes ('
     . 'node int unsigned not null auto_increment primary key,'
     . 'refid int unsigned not null,'
     . 'parent int unsigned not null,'
     . 'disk int unsigned not null,'
     . 'size int unsigned not null,'
     . 'mtime datetime not null,'
     . "ntype enum('Volume','Comment','Directory','File','Archive',"
              .   "'ArchDir','ArchFile','Owner','Link') not null,"
     . 'index(refid),index(parent),index(disk),index(ntype));';
  mysql_db_query($db, $q, $sq);
  echo "<h1>Installed.</h1>\n";
}
else die('Wrong method');

?>
<center>
<p><a href="./">MemoDisx main</a></p>
</center>
</body>
</html>
