<?php
define(_tocmode_, $_GET['mode'] == 'toc');

function Manual($title, $label) {
if ($title) {
  if (_tocmode_) echo "<li><a target=\"right\" href=\"manual#$label\">$title</a></li>\n";
  else echo "<h2><a name=\"$label\">$title</a></h2>\n";
}
return !_tocmode_;
}

function manfile($fn) {
$fname = "incl.$fn.man." . _ext_ . '.php';
if (!file_exists($fname)) $fname = "incl.$fn.man.en.php";
if (file_exists($fname)) {
  include($fname);
}}

virtual("html-head.html");

if (_tocmode_) {
?>
<script language="Javascript1.2">
<!--
function LoadManual() {
if (window.location.protocol != parent.right.location.protocol ||
    window.location.hostname != parent.right.location.hostname ||
    window.location.pathname != parent.right.location.pathname)
           parent.right.location.href = window.location.protocol + '//'
                                      + window.location.hostname
                                      + window.location.pathname;
}
// -->
</script>

<body onLoad="LoadManual()">
<?php virtual("mtitle"); ?>
<div class="menu">
<p><table width="100%" border="2" frame="box" rules="none">
<tr><td><a href="menu" title="Menu">Menu</a></td></tr>
</table></p>
<?php
if (file_exists('incl.demo.php')) {
?>
<p><table width="100%" border="2" frame="box" rules="none">
<tr><td><a href="http://icebearsoft.euweb.cz/memodisx/"
title="Download MemoDisx" target="_top">Download</a></td></tr>
</table></p>
<?php
}
?>
</div>


<?php
  echo '<p class="title">', _toc_, "</p>\n<ol>\n";
}
else {
  require 'incl.functions.php';
  title();
}
while (list($k, $man) = each($manfiles)) manfile($man);
if (_tocmode_) {
  echo "</ol>\n";
#  virtual('copyright.html'); # The screen is often not high enough
}
?>
</body>
</html>
