<?php
if (Manual('Read the CD contents', 'readcd')) {
?>

<p>This function reads the CD contents into the database. First you must select the source from
which the CD should be read. MemoDisx in Unix system assumes that the mount point is specified in
<code>/etc/fstab</code> and the CD is mountable by all users. MemoDisx will try to mount the CD
unless it is already mounted. The contents of the CD is first displayed by <code>dir&nbsp;/s</code>
in OS/2 or <code>ls&nbsp;-la</code> in Unix. If you really wish to read the contents of this CD
into MemoDisx, define its comment and press <b>Submit</b>. When MemoDisx reads the CD, the names of
directories and archives are displayed so that the WWW browser is forced to keep connection. When
reading is finished, the <a href="#summary">summary information</a> is displayed.</p>

<p><b>Notes:</b></p>
<ol>
<li>In some Linux distributions <code>umount</code> only unmounts the CD without ejecting it.</li>
<li>If you do not request unmounting the CD in the form, you must do it manually. If you wish to
have "Eject CD after reading" as default, add <code>checked</code> to the <code>input</code> tag on
line 219 of file <code>incl.readcd.php</code>. The tag should thus be:</li>
</ol>
<pre>
&lt;input type=checkbox name="eject" checked /&gt;
</pre>

<?php
}
?>
