<?php
if (Manual('Vyhledvn soubor a adres', 'search')) {
?>

<p>Funkce slou k vyhledvn textu ve jmnech svazk (volume), soubor a adres, jako i v
komentch. Pamatujte si, e se ve jmnech rosliuj mal a velk psmena, proto i vyhledvn je
na mal a velk psmena citliv. Mete vyhledvat v jednom ze t reim:</p>

<ol>
<li><b>etzec:</b> MemoDisx se pokus najt zadan text jako st libovolnho jmna. Nen to test
rovnosti, je implementovn jako vyhledvn v syntaxi MySQL. Znaky procento, podtrtko a zptn
lomtko maj zvltn vznam. Chcete-li je pout v hledanm etzci, vlote ped n zptn
lomtko.</li>

<li><b>vraz v syntaxi MySQL:</b> vraz uvan v porovnn <code>like</code> popsanm v manulu
MySQL.</li>

<li><b>regulrn vraz v syntaxi POSIX:</b> tento typ vyhledvn se sna bt necitliv na mal a
velk psmena. Konvertuje vechny znaky na znakov skupiny, nap. <code>inSeNsiTivE</code> bude
hledno jako <code>[iI][nN][sS][eE][nN][sS][iI][tT][iI][vV][eE]</code>. Konverze je provdna v
systmovm defaultnm locale. Bohuel, funkce <code>setlocale</code> nefunguje sprvn ve vech
implementacch PHP. Znaky s diakritickmi znamnky tedy nemus bt sprvn oeteny. Mete je vak
zadat explicitn, nap. <code>uj[&eacute;&Eacute;]vi</code> bude konvertovno na
<code>[uU][jJ][&eacute;&Eacute;][vV][iI]</code>.</li>
</ol>

<p>MemoDisx pot zobraz nalezen poloky, kde nzvy svazk, adres a archiv jsou hypertextovmi
odkazy do detailnho pohledu. Detailn pohled je uveden aktuln cestou, vlastnkem CD a
komentem. Vechny sti cesty jsou hypertextovmi odkazy. Doln st okna ukazuje obsah adrese.
Poloky jsou vizuln odlieny. Vznam styl si zobrazte stisknutm tlatka <b>Styly</b> v levm
rmu. Jejich vznam je nsledujc:</p>

<table>
<tr valign="top"><td><span class="IDnum">ID</span></td>
<td>Identifikan slo dodan programem MemoDisx</td></tr>
<tr valign="top"><td><span class="Volume">Volume</span></td>
<td>Jmno svazku</td></tr>
<tr valign="top"><td><span class="Owner">Owner</span></td>
<td>Uivatel, kter naetl CD do databze</td></tr>
<tr valign="top"><td><span class="Comment">Comment</span></td>
<td>Uivatelem zadan koment</td></tr>
<tr valign="top"><td><span class="Directory">Directory</span></td>
<td>Jmno adrese</td></tr>
<tr valign="top"><td><span class="File">File</span></td>
<td>Jmno souboru, kter nen archivem</td></tr>
<tr valign="top"><td><span class="Archive">Archive</span></td>
<td>Archiv znm programu MemoDisx</td></tr>
<tr valign="top"><td><span class="ArchDir">Arch.&nbsp;Directory</span></td>
<td>Adres v archivu</td></tr>
<tr valign="top"><td><span class="ArchFile">Archive&nbsp;File</span></td>
<td>Soubor v archivu</td></tr>
<tr valign="top"><td><span class="Link">Link</span></td>
<td>Jmno symbolickho linku</td></tr>
</table>

<p>MemoDisx povoluje duplikovan jmna svazk s jednou vjimkou. Pokud nezadte parametr
<code>-V</code> v programu <code>mkisofs</code>, bude jmno svazku <code>CDROM</code>. V takovm
ppad MemoDisx pipoj ke jmnu slo.</p>

<p>Pokud jste vlastnkem CD nebo nen vlastnk uveden nebo jste pihlen jako <b>memodisx</b>,
zobraz se tlatko umoujc <a href="#remove">vymazn CD z databze</a>.</p>

<?php
}
?>
